/*----------------------------------------------------------------------------*/
/*checkrd.c  -- routines for reading restart files with the suffix .ind,      */
/*               containing individuals (chromosomes).  Also includes         */
/* the key MIGRATION routines which move individuals among subpopulations.    */
/* Includes functions:                                                        */
/*       read_checkpointfile(), GetMigrants(), GetFitnessBiasedMigrant        */
/*       transform_inversion_pattern(), transform_inversion_pattern_uneq_flds,*/
/*       InitCPRead(), EndCPRead(), NthIndRead(), and FreeUpMigrantHolder()   */
/*----------------------------------------------------------------------------*/


#include "stdafx.h"
#include "GAWind.h"
#include "GAWindDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include <stdlib.h>
#include <stdio.h>
#include "external.h"

#define DEBUG_INVERSION 0
#define RETRIES 10 

/* Defines below are positions in .ind files of individuals. */
#define SEEK_SET                0
#define SEEK_CUR                1 /* as in stdio.h */
#define MVerPos                 0
#define MIndCntPos              (MVerPos + sizeof(int))
#define MIndSizePos             (MIndCntPos + sizeof(int))
#define MChromSizePos           (MIndSizePos + sizeof(int))
#define MBestNowPos             (MChromSizePos+sizeof(int))

static struct individual migrant_holder;
static FILE *fpread;
static int IndCnt;
static int IndSize;
static int ChromSize;
static int BestInd;
static int buf_pos = 0;
static unsigned long mask, indexnum;
static unsigned long MInd0thPos;
static BOOL no_read_intrpt;

#ifdef PROTOTYPES_ACCEPTED
static BOOL NthIndRead(struct individual*, int, BOOL(*)(int*, FILE*));
static BOOL InitCPRead(char *fname, int ownfile, int retries);
static BOOL EndCPRead(char *fname, int ownfile, int retries, BOOL*);
#else
static BOOL NthIndRead();
static BOOL InitCPRead();
static BOOL EndCPRead();
#endif

















