/*----------------------------------------------------------------------------*/
/* report.c - generation report files                                         */
/*----------------------------------------------------------------------------*/


#include "stdafx.h"
#include "MSetar.h"
#include "MSetarDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#include <stdlib.h>
#include <stdio.h>
#include "external.h"


/* Write the population report */
void report() {

/*
	int     indnum;

    if (quiet == 0) {
		repchar(outfp, "-", LINELENGTH);
        skip(outfp, 1);
        if (printstrings == 1) {
			repchar(outfp, " ", ((LINELENGTH - 17) / 2));
	        fprintf(outfp, "Population Report\n");
	        fprintf(outfp, "Individual Number\n");
	        fprintf(outfp, "Generation %d:  \n", gen);
	        fprintf(outfp, "old chromosome (binary)\n");
			if (alpha_size != 2) fprintf(outfp, "old chromosome as int fields\n");
	        fprintf(outfp, "raw fitness | scaled fitness\n");
	        fprintf(outfp, "Generation %d:  \n", (gen + 1));
	        fprintf(outfp, "new chromosome (binary)\n");
	        if (alpha_size != 2) fprintf(outfp, "new chromosome as int fields\n");
	        skip(outfp, 1);
	        fprintf(outfp, "raw fitness | scaled fitness    ");
	        fprintf(outfp, "new string's parents, xsite(s) \n");
	        repchar(outfp, "-", LINELENGTH);
	        skip(outfp, 1);

	        writepop();

	        skip(outfp, 1);
		}
*/

/*
		// give application chance to do itself in its own format, if wants. 
        app_print_strings();

		// write the summary statistics in global mode  
		fprintf(outfp, "Generation %d Accumulated Statistics: \n", gen);
		fprintf(outfp,"Tot.Crossovers = %ld, Tot.Mutations = %ld, Tot.Eval'ns = %ld\n",ncross, nmutation, neval);
        fprintf(outfp,"Raw fitnesses: min= %13.9g, max= %13.9g,\n                avg= %13.9g"
			, minraw, newpop[bestnow].init_fitness, avgraw);
        if ((conv_sigma_coeff != 7. && convinterval != 0 && gen % convinterval == 0) || sigma_trunc != 0.)
			fprintf(outfp, ", sigma= %13.9f", sigma);
		fprintf(outfp, "\n");
        if (beta >= 0.)  fprintf(outfp, "Boltzmann's beta= %f\n", beta);
        fprintf(outfp, "Scaled fitnesses:  min = %13.9g, max = %13.9g,\n                   avg = %11g, sum = %11f\n",
			fit_min, fit_max, fit_avg, sumfitness);
        if (convinterval != 0) {
			fprintf(outfp, "Convergence:  %6.2f%% alleles lost, ", percent_lost);
			fprintf(outfp, "%6.2f%% converged, ", percent_converged);
            fprintf(outfp, "avg. bias %6.2f%%\n", avg_bias);  
		}
		fprintf(outfp, "\nOn-Line Performance = %f, ", on_line_performance);
		fprintf(outfp, "Off-Line Performance = %f\n", off_line_performance);
	}//close quit==0
*/

/*
	if (quiet < 3 ) {
		indnum = bestnow + 1;
		// add one to indnum for external numbering 
		fprintf(outfp, "Best Individual of New Generation %d: Indiv. #: %d,", gen, indnum); 
        fprintf(outfp, " evaluation #: %ld\n", newpop[bestnow].neval);
        fprintf(outfp, "    Init_Fitness = %13.9g ; Rescaled Fitness = %13.9g\n",
			newpop[bestnow].init_fitness, newpop[bestnow].fitness);
	}

	if (quiet == 0 || (quiet == 1 && popno == 0)) {
		fprintf(outfp, "    Chromosome of Best of New Generation:\n");
        //writechrom(newpop[bestnow].chrom);
        if (alpha_size != 2) writefields(newpop[bestnow].chrom);
        skip(outfp, 1);
  
        if (!elitism) {
			fprintf(outfp, "Best Individual Ever of this Population, Generation %d:\n",bestfit.generation);
	        fprintf(outfp, "   Init_Fitness = %13.9g ; Rescaled Fitness = %13.9g\n",bestfit.init_fitness, bestfit.fitness);
	        fprintf(outfp, "   Evaluation number of Best Ever of this Population = %ld \n", bestfit.neval);
	        fprintf(outfp, "    Chromosome of Best Individual Ever of this Population: \n");
	        //writechrom((&bestfit)->chrom);
	        if (alpha_size != 2) writefields((&bestfit)->chrom);
			skip(outfp, 1);
		}
		if (elitism) fprintf(outfp," Eval. No. when Best Ever of this Population FIRST found = %ld \n", bestfit.neval);
*/		
		/* application dependent report */
        app_report();

//		if (convinterval != 0 /* && gen != 0 */ && gen % convinterval == 0 && quiet == 0)
//			reptconv();
//	}

}

void writepop() {

    struct individual *pind;
    int     j;

    for (j = 0; j < popsize; j++) {

		fprintf(outfp, "%3d) \n", j + 1);

	    /* Old string */
	    pind = &(oldpop[j]);
	    //writechrom(pind->chrom);
	    if (alpha_size != 2)  writefields(pind->chrom);
	    fprintf(outfp, "\n  %13.9g | %13.9g\n", pind->init_fitness, pind->fitness);

		/* New string */
		pind = &(newpop[j]);
		//writechrom(pind->chrom);
		if (alpha_size != 2)  writefields(pind->chrom);
		fprintf(outfp, "\n  %13.9g | %13.9g    ", pind->init_fitness, pind->fitness);
		fprintf(outfp, "(%2d,%2d)   %2d  %2d  \n", pind->parent[0], pind->parent[1], pind->xsite[0], pind->xsite[1]);
	}
}


/* Write a chromosome as a string of ones and zeroes            */
/* note that the most significant bit of the chromosome is the  */
/* RIGHTMOST bit, not the leftmost bit, as would be expected... */

void writechrom(unsigned *chrom) {

    int     j, k, i = 0, stop;
    unsigned mask = 1, tmp;
    int     *fields;

    for (k = 0; k < chromsize; k++) {
		tmp = chrom[k];
	    if (k == (chromsize - 1))
	        stop = lchrom - (k * UINTSIZE);
	    else
	        stop = UINTSIZE;
		for (j = 0; j < stop; j++) {
			i++;
			if (tmp & mask)
				fprintf(outfp, "1");
			else
				fprintf(outfp, "0");
			tmp = tmp >> 1;
			if (i % LINELENGTH == 0)
				fprintf(outfp, "\n");
		}
	}
}

/* Write a non-binary chromosome as a string of ints, 10 per line.      */
/* Added 5/96 by EDG (for binary, better to use writechrom(chrom). */
void writefields(unsigned *chrom) {


    int i;    

    fprintf(outfp, "\nFields of chrom. as ints:\n");

    for (i=0;i<numfields;i++) {
		getfield(i, numfields, chrom);
		if (i%20 == 0 && i>0) fprintf(outfp, "\n"); 
		fprintf(outfp, "%d, ", getfield(i, numfields, chrom));
    }
}


/* This routine, added by EDG, prints the max of % of 0's or */
/* 1's in each locus, to check for initialization biases and diversity of */
/* population.  It also prints a convergence measure which uses a         */
/* user-specified number of standard deviations above the mean to         */
/* categorize "very" fit individuals, and reports the fraction of them    */
/* which are closer to some other "very" fit individual than they are to  */
/* the current BEST fit individual.  Thus, as his "clones" increase, the  */
/* measure will decline, indicating convergence.  It is controlled by a   */
/* user flag, convinterval, and is NOT called if flag 0.  The special     */
/* value -99.0, is a flag indicating there were no "good" guys to compare */
/* to best (conv_sigma_coeff high, or pop very uniform).                  */
/* This routine also calls for the printing of some "traditional" measures */
/* of convergence and GA performance. */


void reptconv() {

    if (conv_sigma_coeff != 7.) {
		fprintf(outfp,"\nSpecial Converg.: %% other 'good' guys closest to curr. best: ");
	if (conv_measure == -99.0)
	    fprintf(outfp, "NO OTHER 'GOOD' GUYS FOUND.\n");
	else
	    fprintf(outfp, "%5.1f%%\n", conv_measure);
    }

    fprintf(outfp, "%% with Same Value, by Bit Position, for Old Population\n");
    print_pct_conv();        /* Do the printing. */

    app_conv_rept();    /* Do any app-dependent conv. printing wanted. */

}

/* Application-dependent report, called by reptconv() (in report.c) */
/* Note:  user should modify if wants other than 16 sums printed per line.  */
void print_pct_conv() {

    int     j, k, s, l, stop;
    float       percent_same_value;

    s = lchrom / 10;    /* print <= 10 conv. fields/line */
    if (lchrom % 10 != 0) s++;

    for (j = 0; j < s; j++) {
		if (j == (s - 1))
			stop = lchrom - (j * 10);
		else
			stop = 10;
		l = j * 10;
		fprintf(outfp, "%% with same value, for bit positions %2d0 - %2d9 \n", j, j);
		for (k = 0; k < stop; k++) {
			percent_same_value=(ones[l+k]>popsize/2) ? ones[l+k]/(0.01 * popsize) : (popsize - ones[l+k])/(0.01 * popsize);
			fprintf(outfp, "%5.1f ", percent_same_value);
		}
		fprintf(outfp, "\n");
	}

}

