#include "stdafx.h"
#include "GAWind.h"
#include "GAWindDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include <stdio.h>
#include "AllDinamica.h"

void lfit(double **A, double *y, double sig[], int ndat, double a[], int ia[],
	int ma, double **covar, double *chisq, void (*funcs)(double [], double [], int))

{
	int i,j,k,l,m,jj,mfit=0;
	double ym,wt,sum,sig2i,**beta,*afunc, *x;
	//FILE *lfitPtr;

	//if ((lfitPtr =fopen("lfit.txt", "w")) == NULL) printf("File di Output could not be opened\n");

	beta=dmatrix(1,ma,1,1);  // rappresenta la matrice dei termini noti 
	afunc=dvector(1,ma);
	x=dvector(1,ma);


	for (j=1;j<=ma;j++)
		if (ia[j]) mfit++;
	if (mfit == 0) nrerror("lfit: no parameters to be fitted");
	for (j=1;j<=mfit;j++) {
		for (k=1;k<=mfit;k++) covar[j][k]=0.0; //covar  la matrice X'X
		beta[j][1]=0.0;
	}

	// Costruzione del sistema delle equazioni normali
	for (i=1;i<=ndat;i++) {
		for(jj=1; jj<=ma; jj++) x[jj] = A[i][jj];
		(*funcs)(x,afunc,ma);
		ym=y[i];
		if (mfit < ma) {
			for (j=1;j<=ma;j++)
				if (!ia[j]) ym -= a[j]*afunc[j];
		}
		sig2i=1.0/SQR(sig[i]);
		for (j=0,l=1;l<=ma;l++) {
			if (ia[l]) {
				wt=afunc[l]*sig2i;
				for (j++,k=0,m=1;m<=l;m++)
					if (ia[m]) covar[j][++k] += wt*afunc[m];
				beta[j][1] += ym*wt;
			}
		}
	}

	for (j=2;j<=mfit;j++) {
		for (k=1;k<j;k++) {
			covar[k][j]=covar[j][k];
		}
	}
/*	
	fprintf(lfitPtr, "La matrice covar :\n");
    for(i=1; i<= ma; i++){
		for(j=1; j<= ma; j++){
			fprintf(lfitPtr, "%.2f\t", covar[i][j]);
		}
		fprintf(lfitPtr, "\n");
	}

	fprintf(lfitPtr, "La matrice beta :\n");
    for(i=1; i<= ma; i++){
		for(j=1; j<= 1; j++){
			fprintf(lfitPtr, "%.2f\t", beta[i][j]);
		}
		fprintf(lfitPtr, "\n");
	}
	fclose(lfitPtr);
*/
	gaussj(covar,mfit,beta,1);
	for (j=0,l=1;l<=ma;l++)
		if (ia[l]) a[l]=beta[++j][1];
	*chisq=0.0;
	for (i=1;i<=ndat;i++) {
		for(jj=1; jj<=ma; jj++) x[jj] = A[i][jj];
		(*funcs)(x,afunc,ma);
		for (sum=0.0,j=1;j<=ma;j++) sum += a[j]*afunc[j];
		*chisq += SQR((A[i][1]-sum)/sig[i]);
	}
	covsrt(covar,ma,ia,mfit);
	free_dvector(afunc,1,ma);
	free_dmatrix(beta,1,ma,1,1);
}
